CC = armclang
NATIVE_CFLAGS = -Ofast -mcpu=native

SVE_CFLAGS = -Ofast -march=armv8.1-a+sve

SRC = $(wildcard *.c)
NATIVE_OBJ = $(SRC:.c=.native.o)
SVE_OBJ = $(SRC:.c=.sve.o)
ALL_OBJ = $(NATIVE_OBJ) $(SVE_OBJ)

EXE = vec_add

all: $(EXE).sve.exe $(EXE).native.exe

%.native.exe: $(NATIVE_OBJ)
	$(CC) $(NATIVE_CFLAGS) $^ -o $@

%.native.o: %.c
	$(CC) $(NATIVE_CFLAGS) -c $< -o $@

%.sve.exe: $(SVE_OBJ)
	$(CC) $(SVE_CFLAGS) $^ -o $@

%.sve.o: %.c
	$(CC) $(SVE_CFLAGS) -c $< -o $@

clean:
	rm -f *.o *.exe

.PHONY: all clean
.SECONDARY: $(ALL_OBJ)
